local icons={}
local gpu=require("component").gpu
local bit32=require("bit32")
local fill=gpu.fill
local color=gpu.setBackground
local fcolor=gpu.setForeground
local set=gpu.set
local get=gpu.get
local copy=gpu.copy

function icons.unkFile(x,y)
fcolor(0x404040)
set(x,y,"⣾")
set(x+7,y,"⣷")
set(x,y+3,"⢿")
set(x+7,y+3,"⡿")
color(0x404040)
fcolor(0x808080)
set(x+1,y,"⠀⢀⣤⣤⡀⠀")
set(x,y+1,"⠀⠀⠛⠁⢈⣿⠀⠀")
set(x,y+2,"⠀⠀⠀⠰⠟⠁⠀⠀")
set(x+1,y+3,"⠀⠀⠘⠃⠀⠀")
end

function icons.folder(x,y)
fcolor(0xf9d03f)
set(x+7,y+1,"⣷")
set(x,y+3,"⢿")
set(x+7,y+3,"⡿")
fcolor(0xDD9D02)
set(x,y,"⣠⣤⣄")
color(0xF9D03F)
set(x,y+1,"⠛⠛⠋    ")
set(x,y+2,"        ")
set(x+1,y+3,"      ")
end

function icons.lua(x,y)
fcolor(0x404040)
set(x,y,"⣾")
set(x+7,y,"⣷")
fcolor(0x808080)
set(x,y+3,"⢿")
set(x+7,y+3,"⡿")
color(0x404040)
fcolor(0xec6066)
set(x+1,y,"⠤⠄")
set(x+3,y+1,"⠅")
set(x+4,y+2,"⠁")
fcolor(0xc695c6)
set(x+3,y,"⠤⠤")
set(x,y+2," ⠭⠁   ⠉ ")
fcolor(0x60b4b4)
set(x+5,y,"⠠⠤")
fcolor(0xF97B57)
set(x+3,y+1,"⠅")
set(x+4,y+2,"⠁")
fcolor(0xF9AE57)
set(x+4,y+1,"⠭   ")
fcolor(0xffffff)
set(x,y+1," ⠭⠅")
set(x+3,y+2,"⠁")
set(x+5,y+2,"⠁")
color(0x808080)
set(x+1,y+3," .lua ")
end

function icons.lang(x,y)
fcolor(0x0094ff)
set(x+6,y,"⣶⡄")
fcolor(0x0000ff)
set(x,y+3,"⠘⠿    ⠿⠃")
fcolor(0x00ff00)
set(x,y,"⢠⣶")
color(0x0094ff)
set(x+2,y,"⣿⣿⡟⣿")
color(0x0062ff)
set(x,y+1,"⣿⣿⣿⠟⠋ ⡀ ")
color(0x0040ff)
set(x,y+2," ⠉⠿⣆⣠⠈  ")
color(0x0000ff)
set(x+2,y+3," ⠛⠁ ")
end

function icons.txt(x,y)
fcolor(0xffffff)
set(x+1,y,"⣾")
set(x+6,y,"⣷")
set(x+1,y+3,"⢿")
set(x+6,y+3,"⡿")
fcolor(0)
color(0xffffff)
set(x+2,y,"⠛⠘⠃⠛")
set(x+1,y+1,"⠀⠛⠛⠛⠛ ")
set(x+1,y+2,"⠀⠛⠛⠛⠛ ")
set(x+2,y+3,"⠛⠛⠛⠛")
end

function icons.cfg(x,y)
fcolor(0x6a6a6a)
set(x,y,"⢠⣶⣤⣿⣿⣤⣶⡄")
set(x,y+1,"⣤⣿⠋  ⠙⣿⣤")
set(x,y+2,"⠛⣿⣄  ⣠⣿⠛")
set(x,y+3,"⠘⠿⠛⣿⣿⠛⠿⠃")
end

function icons.app(x,y)
fcolor(0x0094ff)
set(x,y,"⣾")
set(x+7,y,"⣷")
set(x,y+3,"⢿")
set(x+7,y+3,"⡿")
color(0x0094ff)
fcolor(0xffffff)
set(x+1,y,"⠀⠀⣠⣄⠀⠀")
set(x,y+1,"⠀⠀⢰⡏⢹⡆⠀⠀")
set(x,y+2,"⠀⠀⣾⣧⣼⣷⠀⠀")
set(x+1,y+3,"⠀⠛⠀⠀⠛⠀")
end

function icons.error(x,y)
fcolor(0xff0000)
set(x,y,"⣾")
set(x+7,y,"⣷")
set(x,y+3,"⢿")
set(x+7,y+3,"⡿")
color(0xff0000)
fcolor(0xffffff)
set(x+1,y,"⣤⡀⠀⠀⢀⣤")
set(x,y+1,"⠀⠈⠻⣦⣴⠟⠁⠀")
set(x,y+2,"⠀⢀⣴⠟⠻⣦⡀⠀")
set(x+1,y+3,"⠛⠁⠀⠀⠈⠛")
end

function icons.pic(x,y)
fcolor(0x28afea)
set(x,y,"⣾")
set(x+7,y,"⣷")
fcolor(0x124888)
set(x,y+3,"⢿")
fcolor(0x436ccb)
set(x+7,y+3,"⡿")
color(0x28afea)
set(x+6,y+2,"⣦⡀")
fcolor(0xffffff)
set(x+1,y,"⠀⠀⠀⠀⣤⡄")
set(x+5,y+1,"⠉⠁⠀")
fcolor(0x124888)
set(x,y+1,"⠀⣠⣤⣄⠀")
set(x,y+2,"⣾")
set(x+4,y+2,"⣷")
color(0x436ccb)
set(x+5,y+2,"⣄")
set(x+6,y+3,"⣧")
color(0x124888)
set(x+1,y+2,"   ")
set(x+1,y+3,"     ")
end

function icons.user(x,y,a)
fcolor(a)
set(x+1,y,"⢠⣶  ⣶⡄")
set(x+1,y+2,"⠘⠿  ⠿⠃")
set(x,y+3,"⢀⣤⣶  ⣶⣤⡀")
color(a)
clr=math.ceil(a)
gg=bit32.rshift(bit32.band(clr,0x00ff00),8)
if gg < 160 then
	fcolor(0xffffff)
else
	fcolor(0)
end
fill(x+3,y,2,4," ")
set(x+1,y+1," ⢸⡇⢸⡇ ")
set(x+3,y+2,"⠐⠂")
end

function icons.copy(x,y,data,a)
copy(data.x[a]+1,data.y[a],8,4,x-data.x[a]-1,y-data.y[a])
end

--function icons.unkFileCopy(x,y,data,a)
--fcolor(0x404040)
--_,_,clr=get(x,y)
--color(clr)
--set(x,y,"⣾")
--_,_,clr=get(x+7,y)
--color(clr)
--set(x+7,y,"⣷")
--_,_,clr=get(x,y+3)
--color(clr)
--set(x,y+3,"⢿")
--_,_,clr=get(x+7,y+3)
--color(clr)
--set(x+7,y+3,"⡿")
--copy(data.x[a]+2,data.y[a],6,4,x-data.x[a]-1,y-data.y[a])
--copy(data.x[a]+1,data.y[a]+1,8,2,x-data.x[a]-1,y-data.y[a])
--end

return icons